import pandas as pd 
import wandb
api = wandb.Api()

# Project is specified by <entity/project-name>
runs = api.runs("parano/synfr")

# table_column_names = [
# "arch",
# "test_acc",
# "val_acc",
# "head",
# "agedb_30_test_acc",
# "agedb_30_val_acc",
# "lfw_val_acc",
# "lfw_test_acc",
# "cplfw_val_acc",
# "cplfw_test_acc",
# "calfw_test_acc",
# "cfp_fp_val_acc",
# "cfp_ff_test_acc",
# ]
table_column_names = [
    "test_acc",
    "agedb_30_test_acc",
    "lfw_test_acc",
    "cplfw_test_acc", 
    "cfp_ff_test_acc",
]


table_columns = dict()
for table_column_name in table_column_names: 
    table_columns[table_column_name] = list()


summary_list, config_list, name_list = [], [], []
for run in runs: 
    # .summary contains the output keys/values for metrics like accuracy.
    #  We call ._json_dict to omit large files 
    #summary_list.append(run.summary._json_dict)

    # # .config contains the hyperparameters.
    # #  We remove special values that start with _.
    # config_list.append(
    #     {k: v for k,v in run.config.items()
    #       if not k.startswith('_')})

    for table_column_name in table_column_names:
        print(run.config)
        print(run.summary._json_dict)
        if table_column_name in run.summary._json_dict:
            table_columns[table_column_name].append(run.summary._json_dict[table_column_name])
        elif table_column_name in run.config: 
            table_columns[table_column_name].append(run.config[table_column_name])
        else:
            table_columns[table_column_name].append(None)
            #raise ValueError(f"Couldnt find {table_column_name} in neither of summary nor configs")

    # .name is the human-readable name of the run.
    name_list.append(run.name)

runs_df = pd.DataFrame({
    "name": name_list,
    **table_columns
    })

runs_df.to_csv("project.csv")
runs_df.to_markdown("./projec.md")